{ ------------------------------------------------------------------- }
{ Program : EJECTCD                                                   }
{ Purpose : Eject CD-ROM                                              }
{ Updated : Frank-Peter Schultze <fpschultze@bigfoot.de>, 2001-03-29  }
{ ------------------------------------------------------------------- }

{$A-} {$X+} {$D-} {$G+} {$L-}

Uses DOS,CDDEV,CDUTIL;

Var
  DS           : MSCDEX_DevStat;                { saves device status }
  i,j,iVersion : Integer;
  arg          : String;

Const
  iDrive       : Integer = 0;

Begin

  if ParamCount = 0 then
    Begin
      WriteLn( 'Ejects CD-ROM. Syntax: EJECTCD Drive_letter:' );
      Halt(0);
    End;

  iDrive := -1;
  for i := 1 to ParamCount do
    for j := 0 to  25 do
      Begin
        arg := ParamStr(i);
        if( ( UpCase( arg[1] ) = Char ( j + Ord( 'A' ) ) ) AND
            ( arg[ 2 ] = ':' ) AND
            ( Length(arg) = 2 ) ) then iDrive := j;
      End;

  if iDrive < 0 then
    Begin
      Writeln( 'Invalid drive letter.' );
      Halt( 1 );
    End;

  if not MSCDEX_Installed then
    Begin
      Writeln( 'MSCDEX not found' );
      Halt( 1 );
    End;

  iVersion := MSCDEX200_GetVersion;
  if iVersion > $200 then
    if not MSCDEX200_CDRomDriveCheck( iDrive ) then
      Begin
        Writeln( 'The drive specified is not a CD-ROM drive.' );
        Halt( 1 );
      End;

  cd_GetDevStat( iDrive, DS );
  if ( DS.lDeviceStatus AND DS_DOOR_OPEN ) <> 0 then
    cd_CloseTray( iDrive )
  else
    cd_Eject( iDrive );

End.
